{
 Движение по линии до перекрестка
 с помощью двух датчиков света (mot2.pp)

 Требования:
 Два больших мотора, левый подключен к
 порту с меньшим номером, правый - к порту
 с большим номером.
 Два датчика света, левый подключен к
 порту с меньшим номером, правый - к порту
 с большим номером.
}
{$i rubiro.inc}
uses rubiroBase,rubiroMotors,rubiroSensors;
var
 L,R:TEv3ColorSensor;
 Rule:TEv3Rule;

{
 Процедура движения по линии до перекрестка 
 с помощью двух датчиков цвета
 
 maxSpeed - максимально развиваемая скорость
 minSpeed - минимальная скорость
 koef - коэффициент поворота, от 0 (поворот отсутсвует) 
	до 1 (крайне резкий поворот)
 borderBreak - граница черного, выход из процедуры 
	при сумме значений датчиков, меньшей borderBreak 
	(выход по перекрестку)
 borderAcc - граница точности, движение прямо при различии 
	значений датчиков меньшем borderAcc 

}

procedure run(maxSpeed, minSpeed, koef:double; borderBreak, borderAcc:integer);
 var lref,rref,speed:double;
     direct,prevDirect:double;
begin
 try
  speed:=maxSpeed;
  direct:=0;
  prevDirect:=0;
  Rule.Run(direct,speed);
  while true do begin
    lref:=l.reflect; rref:=r.reflect;
    if lref+rref<borderBreak then exit;
    if abs(lref-rref)<borderAcc then direct:=0
    else direct:=(lref-rref)*koef;
    if (direct=prevDirect)and(speed>=maxSpeed) then continue;
    if (direct=prevDirect) then speed+=1
    else speed:=minSpeed;
    prevDirect:=direct;
    rule.Run(direct,speed);
  end;
 finally
  rule.stop(saBrake);
 end;
end;

begin
 ev3init();
 Rule:=Tev3Rule.Create;
 l:=TEv3ColorSensor.Create;
 r:=TEv3ColorSensor.Create;
 run(100,40,0.45,50,20);
 readln;
end.
