{
    Файл является частью библиотеки RubiRobotLib

    © 2017-2021 Слинкин Д.А.

    Обработка дисплея контроллера Lego EV3

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}

{$I uev3defines.inc}

unit rubiroScreen;
interface
uses uev3,uev3image,FPImgCanv,FPImage,uev3ftfont,fontEnMono;

{
 штатный шрифт, можно заменить на любой другой TTF
 до вызова ev3Init в программе
}
var _fontName:shortstring='/usr/share/fonts/truetype/dejavu/DejaVuSerif.ttf';

type TEv3Font=(ruSans,ruSerif,ruMono,enSans,enSerif,enMono);


type

  { TEv3Screen }

  // в ev3dev-jessie -  монохромный монитор, можно использовать только
  //                    функции установки черного и белого цветов
  //                    для карандаша, кисти и шрифта
  // в ev3dev-stretch - черно-белый монитор с поддержкой четырех градаций
  //                    серого и хранением в памяти цветного изображения,
  //                    можно использовать все функции установки цветов
  //                    для карандаша, кисти и шрифта

  TEv3Screen=class(TEv3)
    private
      const DejaVuPath='/usr/share/fonts/truetype/dejavu/';
      const VeraPath='/usr/share/fonts/truetype/ttf-bitstream-vera/';
      const Fonts:array[TEv3Font]of string[30]=
           ('DejaVuSans.ttf','DejaVuSerif.ttf','DejaVuSansMono.ttf',
            'Vera.ttf','VeraSe.ttf','VeraMono.ttf');
    private
      flasttext:string;
      flasttextX,flasttextY:integer;
      fimg:TEv3Image;
      ffont:TFreeTypeFont;
      fcanvas:TFPImageCanvas;
      ffontname:string;
      procedure SetfontName(AValue: string);
      function getFPColor(red,green,blue:byte):TFPColor;
    protected

    public
      property fontName:string read FfontName write SetfontName;
      constructor create();
      destructor destroy; override;

      // очистка изображения
      function clear:TEv3Screen;
      // вывод изображения на дисплей
      function show:TEv3Screen;
      // получение изображения с дисплея
      function get:TEv3Screen;

      // запись изображения на диск в png-формате
      function save(name:variant; inverse:boolean=false):TEv3Screen;
      // чтение изображения с диска в png-формате
      function load(name:variant; inverse:boolean=false):TEv3Screen;

      // рисование различных фигур карандашом и кистью
      function line(args:array of const):TEv3Screen;
      function line(x,y:variant):TEv3Screen;
      function line(x1,y1,x2,y2:variant):TEv3Screen;
      function rectangle(x1,y1,x2,y2:variant):TEv3Screen;
      function ellipse(x1,y1,x2,y2:variant):TEv3Screen;
      function circle(x,y,R:variant):TEv3Screen;

      // печать теста стандартным шрифтом
      function print(x,y:variant; arg:variant):TEv3Screen;
      function print(x,y,angle:variant; arg:variant):TEv3Screen;
      function print(x,y:variant; args:array of const):TEv3Screen;
      function print(x,y,angle:variant; args:array of const):TEv3Screen;
      function textWidth(arg:variant):integer;
      function textHeight(arg:variant):integer;
      function boundText(x,y:variant; arg:variant):TRect;
      function boundLastText:TRect;

      // установка параметров кисти
      function brushStyle(style:variant):TEv3Screen; // число от 0
      function brushStd():TEv3Screen;
      function brushNone():TEv3Screen;
      function brushSolid():TEv3Screen;

      // установка цвета кисти
      function brushBlack():TEv3Screen;  // черный
      function brushWhite():TEv3Screen;  // белый
      function brushLight():TEv3Screen;  // светло-серый
      function brushDark():TEv3Screen;   // темно-серый
      function brushColor(Red,Green,Blue:byte):TEv3Screen;

      // установка параметров карандаша
      function penBig():TEv3Screen;
      function penSmall():TEv3Screen;
      function penSize(size:variant):TEv3Screen; // число от 1
      function penStyle(style:variant):TEv3Screen; // число от 0
      function penSolid():TEv3Screen;
      function penNone():TEv3Screen;
      function penStd():TEv3Screen;
      // установка цвета карандаша
      function penBlack():TEv3Screen;  // черный
      function penWhite():TEv3Screen;  // белый
      function penLight():TEv3Screen;  // светло-серый
      function penDark():TEv3Screen;   // темно-серый
      function penColor(Red,Green,Blue:byte):TEv3Screen;

      // установка параметров шрифта
      function fontType(ft:TEv3Font):TEv3Screen;
      function fontBig():TEv3Screen;
      function fontSmall():TEv3Screen;
      function fontRotate(angle:variant):TEv3Screen;
      function fontSize(size:variant):TEv3Screen;
      function fontStd():TEv3Screen;
      // установка цвета шрифта
      function fontBlack():TEv3Screen; // черный
      function fontWhite():TEv3Screen; // белый
      function fontLight():TEv3Screen; // светло-серый
      function fontDark():TEv3Screen;  // темно-серый
      function fontColor(Red,Green,Blue:byte):TEv3Screen;

   public
     // доступ к объекту холста
     property Canvas:TFPImageCanvas read fcanvas;
     // доступ к объекту рисунка
     property Image:TEv3Image read fimg;

   public
     // прямой доступ к видепамяти
     vmemory:pbyte;
  end;

var ev3screen:TEv3Screen=nil;

implementation
uses uev3fb,uev3func,baseunix,unix,sysutils,variants,types,fpcanvas,FPWritePNG, FPReadPNG;

__WARNGLOBALOFF

var fbuffer:pbyte=nil;
    fbf:longint;
    vinfo:fb_var_screeninfo;
    finfo:fb_fix_screeninfo;
    screensize:dword;

procedure createFB;
  begin
   fbf:=fpopen('/dev/fb0',O_RdWr);
   if (fbf < 0) then begin
          writeln(stderr,'Error: cannot open framebuffer device');
          exit;
   end;
   //   writeln('The framebuffer device was opened successfully.');
   if (fpioctl(fbf, FBIOGET_FSCREENINFO, @finfo) < 0) then begin
          writeln(stderr,'Error reading fixed information');
          exit;
   end;
   // Get variable screen information
   if (fpioctl(fbf, FBIOGET_VSCREENINFO, @vinfo) < 0) then begin
          writeln(stderr,'Error reading variable information');
          exit;
   end;
   // writeln(vinfo.xres,' ', vinfo.yres,' ', vinfo.bits_per_pixel);
   screensize := (vinfo.yres * finfo.line_length);
  // Map the device to memory
   fbuffer := fpmmap(nil, screensize, PROT_READ or PROT_WRITE, MAP_SHARED, fbf, 0);
   if (not ptr2int(fbuffer) = 0) then begin
          writeln('Error: failed to map framebuffer device to memory');
          exit;
   end;
   //writeln(finfo.visual);
   //   writeln('The framebuffer device was mapped to memory successfully.');
 end;

procedure destroyFB;
 begin
  fpmunmap(fbuffer,screensize);
  fpclose(fbf);
 end;

procedure hideCursor;
 begin
   //fpsystem('setterm -cursor off');
   if GetEnvironmentVariable('TERM')<>'linux' then exit;
   write(#27'[?25l');flush(stdout);
 end;
 
procedure showCursor;
 begin
   //fpsystem('setterm -cursor on');
   if GetEnvironmentVariable('TERM')<>'linux' then exit;
   write(#27'[?25h');flush(stdout);
 end;

{ TEv3Screen }

procedure TEv3Screen.SetfontName(AValue: string);
begin
  _lock(9);
  try
    if FfontName=AValue then Exit;
    FfontName:=AValue;
    if not assigned(ffont) then ffont:=TFreeTypeFont.Create;
    ffont.Name:=ffontname;
    fcanvas.Font:=ffont;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.getFPColor(red, green, blue: byte): TFPColor;
begin
    if (red+green+blue)=765 then result := ev3WhiteColor
    else
    if (red+green+blue)=0 then result := ev3BlackColor
    else begin
     result.Alpha:=$ffff;
     result.Red:=Red shl 8;
     result.Green:=Green shl 8;
     result.Blue:=Blue shl 8;
    end;
end;

constructor TEv3Screen.create();//'/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf');
begin
 inherited create;
  vmemory:=fbuffer;
  if finfo.visual=2 then begin
   fimg := TEv3imageXRGB.Create;
  end
  else begin
   fimg := Tev3imageBW.Create;
  end;
  fimg.clear;
  fCanvas := TFPImageCanvas.Create (fimg);
  if fileexists(_fontName) then fontName:=_fontName
  else fontType(enMono);
  fontStd();
  penStd();
  brushStd();
end;

destructor TEv3Screen.destroy;
begin
  fcanvas.destroy;
  fimg.destroy;
  ffont.destroy;
  inherited destroy;
end;

function TEv3Screen.clear: TEv3Screen;
begin
  _lock(9);
  try
    result:=self;
    fimg.clear;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.show: TEv3Screen;
begin
 _lock(9);
 try
  result:=self;
  fimg.exportfb(fbuffer^);
 finally
  _unlock(9);
 end;
end;

function TEv3Screen.get: TEv3Screen;
begin
  _lock(9);
  try
    result:=self;
    fimg.importfb(fbuffer^);
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.print(x, y: variant; arg: variant): TEv3Screen;
begin
    result:=self;
    print(x,y,[arg]);
end;

function TEv3Screen.print(x, y, angle: variant; arg: variant): TEv3Screen;
begin
  result:=self;
  print(x,y,angle,[arg]);
end;

function TEv3Screen.print(x, y: variant; args: array of const): TEv3Screen;
  Var I : longint;
      s:string;
begin
    result:=self;
    if High(Args)<0 then exit;
    s:='';
    for i:=0 to High(Args) do s:=s+arg2string(args[i]);
    _lock(9);
    try
      flasttextX:=x;flasttextY:=y;flasttext:=s;
      fcanvas.textout(x,y,s);
    finally
      _unlock(9);
    end;
//    writeln(s);
end;

function TEv3Screen.print(x, y, angle: variant;
  args: array of const): TEv3Screen;
   var _angle:extended;
 begin
   _lock(9);
   try
     result:=self;
     _angle:=ffont.angle;
     fontrotate(angle);
     print(x,y,args);
     fontrotate(_angle);
   finally
     _unlock(9);
   end;
end;

function TEv3Screen.textWidth(arg: variant): integer;
begin
 _lock(9);
 try
  result:=fcanvas.TextWidth(arg);
 finally
   _unlock(9);
 end;
end;

function TEv3Screen.textHeight(arg: variant): integer;
begin
 _lock(9);
 try
  result:=fcanvas.TextHeight(arg);
 finally
   _unlock(9);
 end;
end;

function TEv3Screen.boundText(x, y: variant; arg: variant): TRect;
begin
 _lock(9);
 try
  result:=ffont.getBounds(arg);
 finally
   _unlock(9);
 end;
 inc(result.left,toInt(x));
 inc(result.right,toInt(x));
 inc(result.top,toInt(y));
 inc(result.bottom,toInt(y));
end;

function TEv3Screen.boundLastText: TRect;
begin
 _lock(9);
 try
  result:=ffont.getBounds(flasttext);
 finally
   _unlock(9);
 end;
 inc(result.left,flasttextX);
 inc(result.right,flasttextX);
 inc(result.top,flasttextY);
 inc(result.bottom,flasttextY);
end;

function TEv3Screen.line(args: array of const): TEv3Screen;
Var I,k : longint;
    points:array of tpoint=nil;
begin
  result:=self;
  if High(Args)<2 then exit;
  setlength(points,(high(args)+1) div 2);
  k:=0;
  for i:=0 to length(points)-1 do begin
    points[i]:=Point(arg2int(args[k]),arg2int(args[k+1]));
    inc(k,2);
//    writeln(points[i].x,' ',points[i].y);
  end;
  _lock(9);
  try
    if length(points)=1 then
     fcanvas.line(points[0].x,points[0].y,points[0].x,points[0].y)
    else
     fcanvas.polyline(points);
  finally
   _unlock(9);
  end;

//  s:='';
//  for i:=0 to High(Args) do s:=s+arg2string(args[i]);
//  fcanvas.textout(x,y,s);
//    writeln(s);
end;

function TEv3Screen.line(x, y: variant): TEv3Screen;
begin
  result:=self;
  line([x,y]);
end;

function TEv3Screen.line(x1, y1, x2, y2: variant): TEv3Screen;
begin
  result:=self;
  line([x1,y1,x2,y2]);
end;

function TEv3Screen.rectangle(x1, y1, x2, y2: variant): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    fcanvas.rectangle(x1, y1, x2, y2);
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.save(name: variant; inverse:boolean=false): TEv3Screen;
 var writer : TFPCustomImageWriter;
     istored:boolean;
begin
  result:=self;
  Writer := TFPWriterPNG.Create;
  with TFPWriterPNG(Writer) do
    begin
    indexed := false;
    wordsized := false;
    UseAlpha := false;
    GrayScale := false;
    end;
  _lock(9);
  try
    istored:=fimg.inverse;
    fimg.inverse:=inverse;
    fimg.SaveToFile (name, writer);
    fimg.inverse:=istored;
  finally
    _unlock(9);
  end;
  writer.free;
end;

function TEv3Screen.load(name: variant; inverse:boolean=false): TEv3Screen;
 var reader : TFPCustomImageReader;
     istored:boolean;
begin
 result:=self;
 reader := TFPReaderPNG.Create;
 _lock(9);
 try
   istored:=fimg.inverse;
   fimg.inverse:=inverse;
   fimg.LoadFromFile (name, reader);
   fimg.inverse:=istored;
 finally
   _unlock(9);
 end;
 reader.free;
end;

function TEv3Screen.ellipse(x1, y1, x2, y2: variant): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    fcanvas.Ellipse(x1,y1,x2,y2);
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.circle(x, y, R: variant): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    fcanvas.Ellipse(x - R div 2,y-R div 2,x+r Div 2,y + R div 2);
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.brushStyle(style: variant): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    fcanvas.brush.style:= style;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.brushStd(): TEv3Screen;
begin
  result:=self;
  brushNone;
  brushBlack;
end;

function TEv3Screen.brushNone(): TEv3Screen;
begin
  result:=self;
  brushStyle(1);
end;

function TEv3Screen.brushSolid(): TEv3Screen;
begin
  result:=self;
  brushStyle(0);
end;

function TEv3Screen.brushBlack(): TEv3Screen;
begin
  result:=brushColor(0,0,0);
end;

function TEv3Screen.brushWhite(): TEv3Screen;
begin
  result:=brushColor(255,255,255);
end;

function TEv3Screen.brushLight(): TEv3Screen;
begin
 result:=brushColor(160,160,160);
end;

function TEv3Screen.brushDark(): TEv3Screen;
begin
 result:=brushColor(80,80,80);
end;

function TEv3Screen.brushColor(Red, Green, Blue: byte): TEv3Screen;
 var color:TFPColor;
begin
 result:=self;
 color:=getFPColor(red,green,blue);
 _lock(9);
 try
   fcanvas.brush.FPColor:=color;
 finally
  _unlock(9);
 end;
end;

function TEv3Screen.penBig(): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    fcanvas.pen.Width:=fcanvas.pen.Width+1;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.penSmall(): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    if fcanvas.pen.Width=1 then exit;
    fcanvas.pen.Width:=fcanvas.pen.Width-1;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.penSize(size: variant): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    fcanvas.pen.Width:=size;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.penStyle(style: variant): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    fcanvas.pen.style:=style;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.penSolid(): TEv3Screen;
begin
  result:=self;
  penstyle(psSolid);
end;

function TEv3Screen.penNone(): TEv3Screen;
begin
  result:=self;
  penstyle(psClear);
end;

function TEv3Screen.penStd(): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    with fcanvas.pen do begin
     mode := pmCopy;
     style := psSolid;
     width := 1;
     FPColor := ev3blackColor;
    end;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.penBlack(): TEv3Screen;
begin
  result:=penColor(0,0,0);
end;

function TEv3Screen.penWhite(): TEv3Screen;
begin
  result:=penColor(255,255,255);
end;

function TEv3Screen.penLight(): TEv3Screen;
begin
 result:=penColor(160,160,160);
end;

function TEv3Screen.penDark(): TEv3Screen;
begin
 result:=penColor(80,80,80);
end;

function TEv3Screen.penColor(Red, Green, Blue: byte): TEv3Screen;
 var color:TFPColor;
begin
 result:=self;
 color:=getFPColor(red,green,blue);
 _lock(9);
 try
  fcanvas.pen.FPColor:=color;
 finally
  _unlock(9);
 end;
end;

function TEv3Screen.fontType(ft: TEv3Font): TEv3Screen;
 var fn:string;
begin
 result:=self;
 if ft<enSans then fn:=DejaVuPath+Fonts[ft]
 else fn:=VeraPath+Fonts[ft];
 if not FileExists(fn) then begin
   fn:=GetTempDir+Fonts[ft];
   if not FileExists(fn) then begin
     fn:=GetCurrentDir+Fonts[ft];
     if not FileExists(fn) then exit;
   end;
 end;
 fontname:=fn;
end;

function TEv3Screen.fontBig(): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    ffont.size:=ffont.size+1;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.fontSmall(): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    ffont.size:=ffont.size-1;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.fontRotate(angle: variant): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    ffont.angle:=(2*pi/360)*angle;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.fontSize(size: variant): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    ffont.size:=size;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.fontStd(): TEv3Screen;
begin
  result:=self;
  _lock(9);
  try
    with ffont do begin
     AntiAliased:=false;
     //Name:=_fontName;
     Size:=14;
     FPColor:=ev3BlackColor;
    end;
  finally
    _unlock(9);
  end;
end;

function TEv3Screen.fontBlack(): TEv3Screen;
begin
 result:=fontColor(0,0,0);
end;

function TEv3Screen.fontWhite(): TEv3Screen;
begin
  result:=fontColor(255,255,255);
end;

function TEv3Screen.fontLight(): TEv3Screen;
begin
 result:=fontColor(160,160,160);
end;

function TEv3Screen.fontDark(): TEv3Screen;
begin
 result:=fontColor(80,80,80);
end;

function TEv3Screen.fontColor(Red, Green, Blue: byte): TEv3Screen;
 var color:TFPColor;
begin
 result:=self;
 color:=getFPColor(red,green,blue);
 _lock(9);
 try
  ffont.FPColor:=color;
 finally
  _unlock(9);
 end;
end;


procedure init; begin hideCursor(); createFB(); ev3Screen:=TEv3Screen.create(); end;
procedure done; begin ev3screen.free; destroyFB(); showCursor(); end;

initialization
   PushInit(@init);
   PushDone(@done);
end.

