{
    Файл является частью библиотеки RubiRobotLib

    © 2017-2021 Слинкин Д.А.

    Низкоуровневая поддержка датчиков и двигателей. 
    Базовые типы данных, переменные и константы
    для модуля uev3

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}

// типы для имен атрибутов
type
     TLongName=string[30];
     TShortName=string[20];
     TShortNames=array[byte]of TShortName;
     PShortNames=^TShortNames;

// типы управляемых систем
type  TEv3DeviceSystem=(ev3dSensors,ev3dTahoMotors,ev3dPorts);
      TEv3DeviceSystems=set of TEv3DeviceSystem;
// определяющие каталоги для типов управляемых систем
const ev3DeviceSystems:array[TEv3DeviceSystem]of TLongName=
       ('/sys/class/lego-sensor','/sys/class/tacho-motor','/sys/class/lego-port');

// все типы поддерживаемых устройств
type  TEv3DeviceType=(ev3tUnknownDevice,
            ev3tUltraSensor,ev3tGyroSensor,ev3tColorSensor,ev3tTouchSensor,ev3tInfraSensor,
            nxttTouchSensor,nxttUltraSensor,nxttLightSensor,
            ev3tLTachoMotor,ev3tMTachoMotor,
            ev3tLegoInputPort,ev3tLegoOutputPort, // названия устройств портов в jessie
            ev3tLegoInputPortStretch,ev3tLegoOutputPortStretch // названия устройств портов в stretch
            );

      TEv3DeviceTypes=set of TEv3DeviceType;

 const ev3DeviceType:array[1..4,TEv3DeviceType] of TShortName=
        (
         ('','ev3ultra','ev3gyro','ev3color','ev3touch','ev3infra','nxttouch','nxtultra','nxtlight','ev3motor','ev3mmotor','','','',''),
         ('','ultra','gyro','color','touch','infra','ntouch','nultra','nlight','lmotor','mmotor','','','',''),
         ('','ультра','гиро','цвет','кнопка','инфра','нкнопка','нультра','нсвет','большой','средний','','','',''),
         ('','','','','','','','','','largemotor','mediummotor','','','','')
        );

// распределение типов устройств по системам
const ev3Devices:array[TEv3DeviceSystem] of TEv3DeviceTypes=(
       [ev3tUltraSensor,ev3tGyroSensor,ev3tColorSensor,ev3tTouchSensor,ev3tInfraSensor,
        nxttTouchSensor,nxttUltraSensor,nxttLightSensor],
       [ev3tLTachoMotor,ev3tMTachoMotor],
       [ev3tLegoInputPort,ev3tLegoOutputPort,
        ev3tLegoInputPortStretch,ev3tLegoOutputPortStretch]);

// идентификаторы типов устройств
Type TEv3ID=record
      Driver,
      PortMode,
      PortSetDevice:TShortName;
     end;

const ev3IDs:array[TEv3DeviceType] of TEv3ID=(
   (Driver:'unknown'; PortMode:'auto'; PortSetDevice:''),
   (Driver:'lego-ev3-us'; PortMode:'ev3-uart'; PortSetDevice:''),
   (Driver:'lego-ev3-gyro'; PortMode:'ev3-uart'; PortSetDevice:''),
   (Driver:'lego-ev3-color'; PortMode:'ev3-uart'; PortSetDevice:''),
   (Driver:'lego-ev3-touch'; PortMode:'auto'; PortSetDevice:''),
   (Driver:'lego-ev3-ir'; PortMode:'auto'; PortSetDevice:''),
   (Driver:'lego-nxt-touch'; PortMode:'auto'; PortSetDevice:'lego-nxt-touch'),
   (Driver:'lego-nxt-ultra'; PortMode:'auto'; PortSetDevice:''),
   (Driver:'lego-nxt-light'; PortMode:'auto'; PortSetDevice:'lego-nxt-light'),
   (Driver:'lego-ev3-l-motor'; PortMode:'tacho-motor'; PortSetDevice:'lego-ev3-l-motor'),
   (Driver:'lego-ev3-m-motor'; PortMode:'tacho-motor'; PortSetDevice:'lego-ev3-m-motor'),
   (Driver:'legoev3-input-port'; PortMode:''; PortSetDevice:''),
   (Driver:'legoev3-output-port'; PortMode:''; PortSetDevice:''),
   (Driver:'ev3-input-port'; PortMode:''; PortSetDevice:''),
   (Driver:'ev3-output-port'; PortMode:''; PortSetDevice:'')
);

// все атрибуты устройств
type  TEv3DeviceAttribute=(
            ev3adriver_name,
            ev3aaddress,
            // sensors
            ev3abin_data,ev3abin_data_format,ev3acommand,ev3acommands,
            ev3adirect,ev3adecimals,ev3afw_version,
            ev3amode,ev3amodes,ev3anum_values,ev3apoll_ms,ev3aunits,
            ev3avalue0,ev3avalue1,ev3avalue2,ev3avalue3,ev3avalue4,ev3avalue5,
            ev3avalue6,ev3avalue7,ev3atext_value,
            // + motors
            ev3acount_per_rot,ev3acount_per_m,ev3afull_travel_count,
            ev3aduty_cycle,ev3aduty_cycle_sp,ev3apolarity,ev3aposition,
            ev3ahold_pid_Kd,ev3ahold_pid_Ki,ev3ahold_pid_Kp,
            ev3amax_speed,ev3aposition_sp,ev3aspeed,ev3aspeed_sp,ev3aramp_up_sp,ev3aramp_down_sp,
            ev3aspeed_pid_Kd,ev3aspeed_pid_Ki,ev3aspeed_pid_Kp,
            ev3astate,ev3astop_action,ev3astop_actions,ev3atime_sp,
            // + ports
            ev3aset_device,
            ev3astatus//, ev3auevent
            );
      TEv3DeviceAttributes=set of TEv3DeviceAttribute;

const ev3DeviceAttributes:array[TEv3DeviceSystem] of TEv3DeviceAttributes=(
       // датчики
       [ev3adriver_name,ev3aaddress,ev3abin_data,ev3abin_data_format,ev3acommand,ev3acommands,
        ev3adirect,ev3adecimals,ev3afw_version,
        ev3amode,ev3amodes,ev3anum_values,ev3apoll_ms,ev3aunits,
        ev3avalue0,ev3avalue1,ev3avalue2,ev3avalue3,ev3avalue4,ev3avalue5,
        ev3avalue6,ev3avalue7,ev3atext_value],
        // моторы
       [ev3adriver_name,ev3aaddress,ev3acommand,ev3acommands,
        ev3acount_per_rot,ev3acount_per_m,ev3afull_travel_count,
        ev3aduty_cycle,ev3aduty_cycle_sp,ev3apolarity,ev3aposition,
        ev3ahold_pid_Kd,ev3ahold_pid_Ki,ev3ahold_pid_Kp,
        ev3amax_speed,ev3aposition_sp,ev3aspeed,ev3aspeed_sp,ev3aramp_up_sp,ev3aramp_down_sp,
        ev3aspeed_pid_Kd,ev3aspeed_pid_Ki,ev3aspeed_pid_Kp,
        ev3astate,ev3astop_action,ev3astop_actions,ev3atime_sp],
        // порты
       [ev3adriver_name,ev3aaddress,
        ev3amode,ev3amodes,
        ev3aset_device,
        ev3astatus
        //,ev3auevent
        ]
       );

// структура описания атрибута
type TEv3DataAttribute=record
      name:TShortName; // имя файла атрибута
      access:TEv3DataMode; // режим доступа к атрибуту
     end;

// описание атрибутов устройств
const ev3DeviceAttribute:array[TEv3DeviceAttribute]of TEv3DataAttribute=(

      (name:'driver_name'; access:ev3ReadOnly),(name:'address'; access:ev3ReadOnly),
      (name:'bin_data'; access:ev3ReadOnly),
      (name:'bin_data_format'; access:ev3ReadOnly),(name:'command'; access:ev3WriteOnly),
      (name:'commands'; access:ev3ReadOnly),(name:'direct'; access:ev3ReadWrite),
      (name:'decimals'; access:ev3ReadOnly),
      (name:'fw_version'; access:ev3ReadOnly),(name:'mode'; access:ev3ReadWrite),
      (name:'modes'; access:ev3ReadOnly),(name:'num_values'; access:ev3ReadOnly),
      (name:'poll_ms'; access:ev3ReadWrite),(name:'units'; access:ev3ReadOnly),
      (name:'value0'; access:ev3ReadOnly),(name:'value1'; access:ev3ReadOnly),
      (name:'value2'; access:ev3ReadOnly),(name:'value3'; access:ev3ReadOnly),
      (name:'value4'; access:ev3ReadOnly),(name:'value5'; access:ev3ReadOnly),
      (name:'value6'; access:ev3ReadOnly),(name:'value7'; access:ev3ReadOnly),
      (name:'text_value'; access:ev3ReadOnly),

      (name:'count_per_rot'; access:ev3ReadOnly),(name:'count_per_m'; access:ev3ReadOnly),
      (name:'full_travel_count'; access:ev3ReadOnly),(name:'duty_cycle'; access:ev3ReadOnly),
      (name:'duty_cycle_sp'; access:ev3ReadWrite),(name:'polarity'; access:ev3ReadWrite),
      (name:'position'; access:ev3ReadWrite),(name:'hold_pid/Kd'; access:ev3ReadWrite),
      (name:'hold_pid/Ki'; access:ev3ReadWrite),(name:'hold_pid/Kp'; access:ev3ReadWrite),
      (name:'max_speed'; access:ev3ReadOnly),(name:'position_sp'; access:ev3ReadWrite),
      (name:'speed'; access:ev3ReadOnly),(name:'speed_sp'; access:ev3ReadWrite),
      (name:'ramp_up_sp'; access:ev3ReadWrite),(name:'ramp_down_sp'; access:ev3ReadWrite),
      (name:'speed_pid/Kd'; access:ev3ReadWrite),(name:'speed_pid/Ki'; access:ev3ReadWrite),
      (name:'speed_pid/Kp'; access:ev3ReadWrite),(name:'state'; access:ev3ReadOnly),
      (name:'stop_action'; access:ev3ReadWrite),(name:'stop_actions'; access:ev3ReadOnly),
      (name:'time_sp'; access:ev3ReadWrite),

      (name:'set_device'; access:ev3WriteOnly),
      (name:'status'; access:ev3ReadOnly)//,(name:'uevent'; access:ev3ReadOnly)
);

type TEv3Port=(ev3pUnknown,in1,in2,in3,in4,outA,outB,outC,outD);
     TEv3PortSet=set of TEv3Port;

const ev3Port:array[1..3,TEv3port]of TShortName=
       (
        ('none','','','','','A','B','C','D'),
        ('none','','','','','А','В','С','Д'),
        ('','port1','port2','port3','port4','portA','portB','portC','portD')
       );
